/******************************
        Map Data Mover
    By Noxid: July 11 2010
    Transfers map data from a PC .exe to a Mac file
    or vice versa. Currently only compatible with
    transformations between the x86 version of the
    mac data; offset +0x40 has reverse byte order
    in the PPC set.
******************************/

#include <cstdlib>
#include <iostream>

using namespace std;

/********************************
Variables and Constants Definition
********************************/
char notChosenConversionMode = 1;
char error = 0;

//Mapdata hex offsets
#define MAPDATA_PC_OLD 0x937B0
#define MAPDATA_PC_CE 0x9A000
#define MAPDATA_MAC_PPC 0x9FD40
#define MAPDATA_MAC_ASM 0x1467A0
#define NUM_MAPS 95
#define MAPLEN_PC 200
#define MAPLEN_MAC 197

/********************************
Fuction Prototyping
********************************/

void ConvertMacPc();
void ConvertPcMac();

/********************************
Beginning of Code
********************************/

int main(int argc, char *argv[])
{
//Main menu. Choose conversion mode.
    char conversionMode = 0;
    char notExit = 1;

    cout << "This is Noxid's Map Data Tool. " << endl;
    cout << "How to use: A vague and incomplete guide." << endl;
    cout << "1) You have to have the pc .exe and the mac thing" << endl;
    cout << "in the same folder as this program." << endl;
    cout << "2) Follow the prompts as they come up. Giving bad" << endl;
    cout << "input (like too long a string) will not end well.";
    while (notExit)
    {
         cout << endl << endl << "PC to Mac [1] or Mac to PC [2] or exit [3]? ";
         cin >> conversionMode;
         conversionMode -= 0x30;
         cout << endl;
         
         while (notChosenConversionMode) {
        
            switch (conversionMode)
            {
                default: //Invalid entry
                     cout << "Sorry, Invalid entry! " << endl;
                     cout << "PC to Mac [1] or Mac to PC [2] or exit [3]? " << endl;
                     cin >> conversionMode;
                     conversionMode -= 0x30;
                     cout << endl;
                     break;
        
                case 1: 
                     cout << "Thanks! " << endl;
                     notChosenConversionMode = 0;
                     ConvertPcMac(); //Convert
                     break;
                     
                case 2:
                     cout << "Thanks! " << endl;
                     notChosenConversionMode = 0;
                     ConvertMacPc(); //Convert
                     break;

                case 3:
                     notExit = 0;
                     notChosenConversionMode = 0;
                     break;
            }
         }
        notChosenConversionMode = 1;
        if (error)
        {
            cout << "I'm sorry things didn't work out. ";
            error = 0;
        }
    }
    cout << "We're through! Awesome. " << endl;
    system ("PAUSE");
    return EXIT_SUCCESS;
}

void ConvertPcMac() 
{
// Initialize variables, etc.
    char pcName [32] = {'/0'};
    char macName [32] = {'/0'};
    FILE *pc_file;
    FILE *mac_file;
    char *buffer;
    buffer = (char *) malloc(NUM_MAPS*MAPLEN_MAC);
    memset(buffer, 0, NUM_MAPS*MAPLEN_MAC);
    char *buffer_init = buffer;
    char *asciiMapsNum;
    char mapdataType = 0;
    int mapdataLoc = 0;
    size_t result;

// Load the files
    cout << "What is the name of the PC file (including the extension) ";
    cout << endl << "--> ";
    cin >> pcName;
    cout << endl << "Cool. Now the Mac one? ";
    cout << endl << "--> ";
    cin >> macName;
    cout << endl << "Thanks for that. ";

    if ((pc_file = fopen (pcName, "rb")) == NULL)
    {
        cout << endl << "Oops, couldn't open the PC file! ";
        error = 1;
        return;
    }
    if ((mac_file = fopen (macName, "r+b")) == NULL)
    {
        cout << endl << "Oops, couldn't open the Mac file! ";
        error = 1;
        return;
    }

// Determine whether Old or New map data
    while (!mapdataType)
    {
        cout << "Are you using the original PC map data [1]" << endl;
        cout << "Or, the CE map data [2]?" << endl;
        cout << "--> ";
        cin >> mapdataType;
        mapdataType -= 0x30;
        if ((mapdataType > 2) | (mapdataType < 1))
        {
            cout << "No. That's wrong." << endl;
            mapdataType = 0;
        }
    }
            
// Write data from file to buffer
    if (mapdataType == 1) mapdataLoc = MAPDATA_PC_OLD;
    else mapdataLoc = MAPDATA_PC_CE;

    for (int map = 0; map < NUM_MAPS; map++)
    {
        fseek (pc_file, (mapdataLoc + (map * MAPLEN_PC)), SEEK_SET);
        result = fread (buffer, 1, MAPLEN_MAC, pc_file);
        buffer += MAPLEN_MAC;
    }

// Write data from buffer to File
    buffer = buffer_init;
/*
    fseek (mac_file, MAPDATA_MAC_PPC, SEEK_SET);
    fwrite (buffer, 1, (NUM_MAPS*MAPLEN_MAC), mac_file);
*/
    fseek (mac_file, MAPDATA_MAC_ASM, SEEK_SET);
    fwrite (buffer, 1, (NUM_MAPS*MAPLEN_MAC), mac_file);

// Release memory
    fclose (pc_file);
    fclose (mac_file);
    free (buffer);

    return;
}

// Send map data from Mac to PC
void ConvertMacPc()
{
// Initialize variables, etc.
    char pcName [32] = {'/0'};
    char macName [32] = {'/0'};
    FILE *pc_file;
    FILE *mac_file;
    char *buffer;
    buffer = (char *) malloc(NUM_MAPS*MAPLEN_PC);
    memset(buffer, 0, NUM_MAPS*MAPLEN_PC);
    char *buffer_init = buffer;
    char *asciiMapsNum;
    char mapdataType = 0;
    int mapdataLoc = 0;
    char macMapType = 0;
    size_t result;

// Load the files
    cout << "What is the name of the PC file (including the extension) ";
    cout << endl << "--> ";
    cin >> pcName;
    cout << endl << "Cool. Now the Mac one? ";
    cout << endl << "--> ";
    cin >> macName;
    cout << endl << "Thanks for that. ";

    if ((pc_file = fopen (pcName, "r+b")) == NULL)
    {
        cout << endl << "Oops, couldn't open the PC file! ";
        error = 1;
        return;
    }
    if ((mac_file = fopen (macName, "rb")) == NULL)
    {
        cout << endl << "Oops, couldn't open the Mac file! ";
        error = 1;
        return;
    }

// Determine whether Old or New map data
    while (!mapdataType)
    {
        cout << "Are you using the original PC map data [1]" << endl;
        cout << "Or, the CE map data [2]?" << endl;
        cout << "--> ";
        cin >> mapdataType;
        mapdataType -= 0x30;
        if ((mapdataType > 2) | (mapdataType < 1))
        {
            cout << "No. That's wrong." << endl;
            mapdataType = 0;
        }
    }
// Determine PPC or ASM map data
/************************
while (!macMapType)
    {
        cout << "Do you want to copy from the PPC map data [1]" << endl;
        cout << "Or the x86 map data [2]?" << endl;
        cout << "--> ";
        cin >> macMapType;
        macMapType -= 0x30;
        if ((macMapType > 2) | (macMapType < 1))
        {
            cout << "No. That's wrong." << endl;
            macMapType = 0;
        }
    }
*************************/
// Write data from file to buffer
    if (macMapType == 1) mapdataLoc = MAPDATA_MAC_PPC;
    else mapdataLoc = MAPDATA_MAC_ASM;

    for (int map = 0; map < NUM_MAPS; map++)
    {
        fseek (mac_file, (mapdataLoc + (map * MAPLEN_MAC)), SEEK_SET);
        result = fread (buffer, 1, MAPLEN_MAC, mac_file);
        buffer += MAPLEN_PC;
    }

// Write data from buffer to File
    buffer = buffer_init;

    if (mapdataType == 1)
    {
        fseek (pc_file, MAPDATA_PC_OLD, SEEK_SET);
        fwrite (buffer, 1, (NUM_MAPS*MAPLEN_PC), pc_file);
    } else {    
        fseek (pc_file, MAPDATA_PC_CE, SEEK_SET);
        fwrite (buffer, 1, (NUM_MAPS*MAPLEN_PC), pc_file);
    }
// Release memory
    fclose (pc_file);
    fclose (mac_file);
    free (buffer);

    return;
}
